package net.sf.jasperreports.charts.util;

import java.util.Map;
import net.sf.jasperreports.engine.JRPrintHyperlink;
import org.jfree.chart.entity.CategoryItemEntity;
import org.jfree.chart.entity.ChartEntity;

public class CategoryChartHyperlinkProvider implements ChartHyperlinkProvider {
  private static final long serialVersionUID = 10200L;
  
  private Map itemHyperlinks;
  
  public CategoryChartHyperlinkProvider(Map itemHyperlinks) {
    this.itemHyperlinks = itemHyperlinks;
  }
  
  public JRPrintHyperlink getEntityHyperlink(ChartEntity entity) {
    JRPrintHyperlink printHyperlink = null;
    if (hasHyperlinks() && entity instanceof CategoryItemEntity) {
      CategoryItemEntity itemEntity = (CategoryItemEntity)entity;
      Comparable serie = itemEntity.getDataset().getRowKey(itemEntity.getSeries());
      Map serieHyperlinks = (Map)this.itemHyperlinks.get(serie);
      if (serieHyperlinks != null) {
        Object category = itemEntity.getCategory();
        printHyperlink = (JRPrintHyperlink)serieHyperlinks.get(category);
      } 
    } 
    return printHyperlink;
  }
  
  public boolean hasHyperlinks() {
    return (this.itemHyperlinks != null && this.itemHyperlinks.size() > 0);
  }
}
